import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class DebugCanvas extends Canvas implements MouseListener {
    Manager M; 
    ControlPanel DEBUG;	
    Debugger X;
    ListenSquare STOP,GO;

    public DebugCanvas() {
      addMouseListener(this);
      X=new Debugger();
      setPanels();
      GO=new ListenSquare(110,5,30,20);
      STOP=new ListenSquare(110,25,40,20);
    }


    public void setPanels() {  
	Color[] C1={new Color(0,0,150),Color.white,
          Color.white,Color.white,new Color(180,180,180)};

	 String[] DebugString={"arithmetic","data","composition",
			       "positivity","confiner","print vertices",
                               "diff","recognize","debug"};
	 int[] DebugState={1,0,0,0,0,0,0,0};
         DEBUG=new ControlPanel(C1,DebugString,DebugState,8);
	 DEBUG.mode=0;
    }



   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
       RenderingHints.VALUE_ANTIALIAS_ON);
      g.setColor(new Color(100,100,100));
      g.fillRect(0,0,getWidth(),getHeight());
      drawControls(g);
     
   }

    public void drawControls(Graphics2D g) {
       DEBUG.render(g,0,0,100);
       if(X.HALT==true) {
          GO.render(g,new Color(0,200,0));
          g.setFont(new Font("Helvetica",Font.PLAIN,12));
	  g.setColor(Color.white);
	  g.drawString("go",115,20);
       }  
       if(X.HALT==false) {
	   STOP.render(g,new Color(200,0,0));
          g.setFont(new Font("Helvetica",Font.PLAIN,12));
	  g.setColor(Color.white);
	  g.drawString("stop",115,40);
       }


    }


    public void doRun() {
	if(X.HALT==false) return;
	X=new Debugger(this.M);
        new Thread(X).start();
    }


    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	int d=DEBUG.switchMode(J.X);
        if(d==99) DocumentDebug.info(M);
	if(GO.inside(J.X)==1) doRun();
	if(STOP.inside(J.X)==1) X.HALT=true;
	M.repaint();
    }

    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}   


}

