import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class DebugDifferential {
    Debugger D;


    /**Here is the  derivative of a map f.
       If the map is given by f=(a,b) the coordinates
       of the derivative are

           d[0][0] = d_x a        d[0][1]= d_y a


           d[1][0] = d_x b        d[1][1]= d_y b

       The columns are the standard directional derivatives.
       We just use this file for debugging purposes.  We get
       a numerical approximation to the derivative by taking
       the difference quotient, with h small.**/



    public static double[][] diffMap(int[] A,double[] x0,double h) {
	double d11=diff11Map(A,x0,h);
	double d12=diff12Map(A,x0,h);
	double d21=diff21Map(A,x0,h);
	double d22=diff22Map(A,x0,h);
	double[][] d={{d11,d21},{d12,d22}};
	return(d);
    }

    public static double diff11Map(int[] A,double[] x0,double h) {
	double[] x1={x0[0]+h,x0[1]};
	double[] y0=HeatSemigroup.main(A,x0);
	double[] y1=HeatSemigroup.main(A,x1);
	double t=(y1[0]-y0[0])/h;
	return(t);
    }


    public static double diff12Map(int[] A,double[] x0,double h) {	
	double[] x1={x0[0]+h,x0[1]};
	double[] y0=HeatSemigroup.main(A,x0);
	double[] y1=HeatSemigroup.main(A,x1);
	double t=(y1[1]-y0[1])/h;
	return(t);
    }


    public static double diff21Map(int[] A,double[] x0,double h) {	
	double[] x1={x0[0],x0[1]+h};
	double[] y0=HeatSemigroup.main(A,x0);
	double[] y1=HeatSemigroup.main(A,x1);
	double t=(y1[0]-y0[0])/h;
	return(t);
    }


    public static double diff22Map(int[] A,double[] x0,double h) {	
	double[] x1={x0[0],x0[1]+h};
	double[] y0=HeatSemigroup.main(A,x0);
	double[] y1=HeatSemigroup.main(A,x1);
	double t=(y1[1]-y0[1])/h;
	return(t);
    }
}

