import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;




public class DocumentImage {

    public DocumentImage() {}


    public static void fudgeInfo(Manager M) {
        String S="linear change of coordinates";

	S=S+"\n\nThis lever toggles the application of a linear transformation A to the picture window. The formula is\n\nA(x,y)=[(x+y)/2,(x-y)/(2r)]\n\nwhere r=-(\u03D5^2)/tan(4 Pi/5)=3.60341...";

	S=S+"\n\nGeometrically, the picture is very appealing when A is applied.  The Julia set has 10-fold infinitesimal isometric symmetry about the repelling fixed point at the origin, bilateral symmetry about the x-axis, another repelling fixed point at (1,0), and  the attracting fixed point at infinity out the x-axis. You can see the picture best by applying A and then clicking on the two leftmost preset scales.";

S=S+"\n\nSo, why don't we always apply A?  The problem is that with this normalization the various maps are defined over a quartic number field (thanks to the constant r) whereas without A the map is defined over the number ring Z[\u03D5]. (Open the FORMULAS window to see the formulas.)  So, without A, the map is more appealing from an algebraic standpoint.";

S=S+"\n\nAll this makes me wonder if there is another birational conjugate of the heat map which is nice from both a geometric and algebraic standpoint.";

        Documentation.explain(M,S);
        
    }

    public static void scaleInfo(Manager M) {
        String S="preset scales";

	S=S+"\n\nWhenever you click on the lever, the picture returns to a preset scale. This is useful if you have zoomed very far in or out of the picture and don't know where you are. You can also use the RESET button on the main control panel to do this. ";

        Documentation.explain(M,S);
        
    }

    public static void contrastInfo(Manager M) {
        String S="Julia set color schemes";

	S=S+"\n\nThis bottom row of squares lets you change the color scheme for the Julia set.  The points in the picture plane are colored according to how many times (say N) it takes for the iterate to land in the region represented by convex classes.  We define the following function f:";

	S=S+"\n\n 0,1,2...->0,1,...,5,6,5,...,1,0,1,...\n\nand then it repeats.";

	S=S+"\n\nThe point gets color f(N).";

	S=S+"\n\nmanual: The top 7 squares to the right of this lever contol the colors for the region outside the fundamental domain. The bottom 7 squares control the colors inside the fundamental domain.  You can click on these buttons and change their color to see how the picture plane is changed.\n\n";

S=S+"presets:  If you click on the squares of the lever itself, you get some preset color schemes.  The first preset is greyscale.  The second one is a gentle scheme that lets you see the partition pretty well.  The next two are schemes that I find appealing.  The last one is random, and different every time.";


        Documentation.explain(M,S);
        
    }


    public static void blurInfo(Manager M) {
        String S="Julia set render style";

	S=S+"\n\nThis lever influences the drawing style of the Julia set.\n\n The first settig is regular.\n\n The second setting blurs the lines.\n\nThe third setting sharpens the lines\n\nFor the second and thind settings we use the first pentagram invariant to give additional information about the location of the point.  Thus. a point in the convex region gets a value between 0 and 1, and a point that gets mapped into the convex region gets a value between 1 and 2, and so on.";
        Documentation.explain(M,S);
        
    }

    public static void exportInfo(Manager M) {
        String S="export";

	S=S+"\n\nThis lever toggles the export feature. When the feature is on, the program saves the picture window contents into a PNG file.";

        Documentation.explain(M,S);
        
    }


    public static void quadWidthInfo(Manager M) {
        String S="polygon outline";
	S=S+"\n\nWhen you select a partition piece on the picture window (using the middle mouse button or the key x) the piece gets an outline. This lever controls the width of the outline. This work best with the `polygon feature' on the main display turned off.";
        Documentation.explain(M,S);
        
    }

    public static void triWidthInfo(Manager M) {
        String S="triangulation image line widthl";
	S=S+"\n\nThis lever works in tandem with the 'tri image' option on the display control panel.  This lever controls the line width of the image of the selected piece of the partition.  Read about the tri image feature if you don't know what this means.";
        Documentation.explain(M,S);
        
    }


    public static void zoomInfo(Manager M) {
        String S="zoom";

	S=S+"\n\nOn the picture window, you scale the picture by clicking on the left/right mouse buttons (or using the z-key and c-key.)  The scaling factor is always of the form s/2, where s is a power of the golden ratio. This lever controls the exponent.  The leftmost button is phi^5/2, the next one is phi^4/2.  These are canonical choices.  The power phi^5/2 is exactly the scale factor of the differential of the heat map at the origin -- corresponding to the star regular polygon.";

        Documentation.explain(M,S);
        
    }

    public static void colorSelectorInfo(Manager M) {
        String S="color selector";

	S=S+"\n\nThis is the color selector.  You can either pick a preselected color by clicking on it or you can use the sliders to adjust the RGB and transparency values.  Semi-transparent colors are the most useful for the purposes of the program.  Try clicking around on the color selector to see how the color changes.";

	S=S+"\n\nSome of the control panels have 2 columns of buttons.  The right column of buttons selects and de-selects the objectes.  The left column of buttons determines the colors of the objects. You can change these colors by first choosing a color on the color selector and then clicking on a button in the left column.  As an exercise, try turning the star domain on the main control panel blue.";

        Documentation.explain(M,S);
        
    }


    public static void quadPlotInfo(Manager M) {
        String S="quad plot detail";
	S=S+"\n\nThis lever works in tandem with the 'quad' option on the display control panel.  This lever controls the detail of the plot of the image of the selected quad.  Read about the quad feature if you don't know what this means.";
        Documentation.explain(M,S);
        
    }

    public static void triPlotInfo(Manager M) {
        String S="triangulation image plot detail";
	S=S+"\n\nThis lever works in tandem with the 'tri image' option on the display control panel.  This lever controls the detail of the plot of the image of the selected piece of the partition.  Read about the tri image feature if you don't know what this means.";
        Documentation.explain(M,S);
       
    }



}



