import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



/**this class lets you select the map.*/

public class HandleMap {
    int X,Y; //location of control panel 
    ListenSquare I; //documentation
    Lever[] G=new Lever[4];


    public HandleMap(int x,int y) {
	X=x;
	Y=y;
	G[0]=new Lever(X+5,Y+35,1,2);  //2-symmetry
	G[1]=new Lever(X+5,Y+68,4,5);  //5-symmetry 
	G[2]=new Lever(X+5,Y+100,1,2);  //power of map
	G[3]=new Lever(X+5,Y+132,0,2);  //special toggle
	I=new ListenSquare(X,Y,12,12);
    }



    public int[] getMap() {
	int[] a=new int[4];
	for(int i=0;i<4;++i) a[i]=G[i].val;
	return(a);
    }


    public void render(Graphics2D g) {
	if(G[3].val==0) renderOrdinary(g);
	if(G[3].val==1) renderSpecial(g);
    }


    public void renderOrdinary(Graphics2D g) {
	g.setColor(new Color(0,80,40));
	g.fillRect(X,Y,76,144);
	g.setColor(Color.white);
	g.drawRect(X,Y,76,144);
	g.setFont(new Font("Helvetica",Font.PLAIN,11));
	g.drawString("select map",X+16,Y+12);
	G[0].render2(g,"R^",new Color(0,200,0));
	G[1].render2(g,"G^",new Color(0,200,0));
	G[2].render2(g,"H^",new Color(0,200,0));
	G[3].render(g,"aux(off)",new Color(0,50,0));
	I.infoRender(g);
    }

    public void renderSpecial(Graphics2D g) {
	g.setFont(new Font("Helvetica",Font.PLAIN,11));	
	g.setColor(new Color(180,0,90));
	g.fillRect(X,Y,76,144);
	g.setColor(Color.white);
	g.drawRect(X,Y,76,144);	
	g.drawString("map",X+26,Y+12);
	g.drawString("This is the",X+8,Y+50);
	g.drawString("map B",X+8,Y+72);
	g.drawString("H",X+45,Y+72);
	g.drawString("-1",X+35,Y+64);
        G[3].render(g,"aux(on)",new Color(255,50,180));
	I.infoRender(g);
    }




    public int process(Point P) {
	if(I.inside(P)==1) return(99);
	for(int i=0;i<4;++i) {
            int d=G[i].process(P);
	    if((i==3)&&(d==99)) return(-99);
	}
	return(0);
    }

}
