


public class DocumentProofAlgebra {



    public static String go61(Manager M) {

	String S="All our proofs boil down to showing that a polynomial is non-negative on a polygon.  The polygons all have vertices in the ring R[\u03D5,\u03A8]. Here";
	 S=S+"\n\nR is the ring of dyadic rationals.";
	 S=S+"\n\u03D5=(1+\u221A5)/2.";
	 S=S+"\n\u03A8=(1+\u221A13)/2.";
	 S=S+"\n\nWith the exception of two special points, all the vertices lie in the simpler ring Z[\u03D5]. The coefficients of the coordinates of the vertices are all less than 200, and typically less than 20.";

	 S=S+"\n\nThe polynomials in question are all obtained from the polynomials defining the primary elements of the heat semigroup or their first partial derivatives. Such polynomials are defined over the ring Z[\u03D5].  The maximum total degree we need is 32, and the coefficients of the polynomials we use are not more than 50 digits long.";

	 S=S+"\n\nWe do all the computations using the BigInteger class in java.  This class does exact interval arithmetic with no restriction on the sizes of the integers except the memory alloted to the program. In principle, this means that we could do exact integer arithmetic with integers thousands of digits long.  We don't need this much power, but it is nice to know that there is no worry about overflow error in our calculations.";
       return(S);

    }


    public static String go62(Manager M) {

	String S="Now we will explain how we show computationally that a polynomial is positive on a polygon. Let F be a polynomial and let P be a polygon.  First of all, we triangulate P and reduce to the case of triangles.  So, assume that P is a triangle.";

	S=S+"\n\nLet T0 be the triangle with vertices (0,0), (1,0) (1,1).  Let S0=[0,1]^2.  Let A be one of the 3 affine maps carrying T0 to P.  Let M(x,y)=(x,xy).  Note that M(S0)=T0.  We introduce the auxiliary polynomial\n\nG=FAM\n\nThe map G is positive on S0 if and only if F is positive on P. We write";

	S=S+"\n\nG(x,y)=\u2211 c(i,j)x^iy^j.\n\n";

        S=S+"We let S(a,b) denote the sum of the coefficients c(i,j) where 0<=i<=a and 0<=j<=b. We call G positive dominant if all these S(a,b) are positive.";

	S=S+"\n\nIt is an elementary exercise to show that G is positive on S0 provided that G is positive dominant.  So, the crudest version of our method is to replace F by G=FAM and try to show that G is positive dominant. If this succeeds, we call the pair (F,P) positive dominant. This method usually fails, but we will explain a much more powerful method in the next section.";

       return(S);

    }


    public static String go63(Manager M) {
	int[] a={1,0,0,0,1,0,0,0};
	DocumentProof.setDisplay(M,a);
	M.C.TEST.forceMode(1);
	M.C.TC.setPiece(17,M);
	M.C.STRICT.val=1;
	M.C.TC.FILL.val=0;  
        M.P.setScales(10,399,35);

	String S="We make our basic method  much more powerful by combining it with a recursive subdivision algorithm.  Any triangle can be subdivided into 4 similar copies of the original, each half as large, in an obvious way.";

    S=S+"\n\nLet (F,P) be a pair, where F is a polynomial and P is a triangle. To run our algorithm we maintain a list of triangles, called LIST. Initially, LIST has one member, namely P.  At the current stage of the algorithm, we examine the last triangle Q on LIST. If (F,Q) is positive dominant, we remove Q from the list.  If (F,Q) is not positive dominant, we remove Q from the list and replace Q by the 4 triangle in the subdivision of Q.  We then run the algorithm either until LIST is empty or we reach a triangle that is 8 subdivisions deep.  This arbitrary cutoff of 8 is convenient for our purposes.";

    S=S+"\n\nIf the algorithm halts with an empty list, what we have is a partition of P into finitely many triangles Q1,...,Qn such that (F,Qj) is positive dominant for each j,  Hence, in this case, F is positive on P.";

    S=S+"\n\nIf you want to see the algorithm in action, push the green GO button and watch the partition of triangles appear on the screen.  Here we are running the algorithm which shows that the denominators of the coordinate functions of the map associated to piece 17 are positive.";
        
       return(S);

    }

    public static String go64(Manager M) {
	M.C.TESTCHOICE.turnOn();
	int[] a={1,0,0,0,1,1,0,0};
	DocumentProof.setDisplay(M,a);
	M.C.TEST.forceMode(1);
	M.C.TC.setPiece(37,M);
	M.C.STRICT.val=1;
	M.C.TC.FILL.val=0;  
        M.P.setScales(-200,830,40);

	String S="We actually use two flavors of our algorithm. The one we described above is what we call the HARD version.  Now we describe the other two variants.";

	S=S+"\n\nSOFT:  For the SOFT test, we replace every occurance of the word `positive' with the word 'non-negative'. We also require that that the total sum of all the coefficients is positive. The success of our test then shows that the given polynomial is nonnegative on the given triangle and positive in the interior. Normally we use the soft version, because we don't care if our inequalities are strict.  The one situation where we really care about strict inequalities is when we want to show that the denominators of the rational functions making up our maps do not vanish on various domains. Most of the time we use the hard version for this, but sometimes the hard version fails for one or the other denominators when the piece contains one of the special vertices 12,15,56,57.   If you push the go button you will see that the hard version fails on piece 37.  If you change the setting on the lever marked 'strict', the piece will pass the soft test.";

	S=S+"\n\nThere now arises a subtle point.  It we run the algorithm for the function Q using the soft test, it produces a partition of the piece into triangles T1,...,Tk such that (Tj,Q) is nonnegative dominant for all j.  This means that Q is positive on the interior of Tj.  We have not ruled out the possibility that Q vanishes on some point p of some edge of some Tj.  That is, we don't know that Q is positive in the interior of the original piece.  This situation seems rather unlikely, because the way we chose the subdivision (using the golden ratio) is essentially unrelated to the function Q.";

	S=S+"\n\nTo rule out this irritating complication, we examine the output of the calculation on each triangle Tj, and we observe that in fact (Tj,Q) is positive dominant for all Tj except for the one which contains the spceial vertex.  This implies that Q is positive in the interior of the piece.  (We will explain below how the user can examine the output of the individual calculations.)";

	S=S+"\n\nThere is one other subtlety about out test.  In some cases the polynomials of interest to us really do vanish at points on the boundary of triangle.  In these cases, the algorithm sometimes tends to be less successful.  We augment the algorithm as follows.  Rather than just apply the algorithm to the pair (F,P), we also apply the algorithm to the pairs (F,P') and (F,P''), where P' and P'' are cyclic relabelings of P. This has no effect on the truth of the statement to be proved, but it does cause the test to run with different polynomials.";

       return(S);

    }


    public static String go65(Manager M) {

	String S="We use (one form or another of) the positive dominance algorithm in three different ways.  First, we simply use it to test the positivity, or near positivity of a polynomial on a domain.  In this capacity, we use the test for the following purposes.";

	S=S+"\n\n--To show that the denominators do not vanish on the pieces of the partition where we need to know that the associated primary map is a local homeomorphism.";

	S=S+"\n\n--To show that the denominators vanish at only finitely many points of each of the other pieces in the partition.  This fact is needed for our confiner and excluder tests to run.  We describe these texts below.";

	S=S+"\n\n--To get all the lower bounds on the area expansion and the upper bounds on the sums of squares of partial derivatives.";

       return(S);
    }

    
    public static String go66(Manager M) {

	String S="Confiner Test:  We use this test when we want to show that the image F(P) is contained in a convex polygon Q.  More simply, we have a rational map F, a polygon P, and a line L, and we would like to show that F(P) does not cross L.  Call this the line test.  Once we have the line test, we apply it in sequence to the lines extending the edges of Q.  If the pair (F,P) passes all these line tests, then F(P) does not cross any of the edges of P.  We then check explicitly that F maps one point of P into Q, and this combines with the non-crossing information to show that F(P) is contained in Q.";

	S=S+"\n\n For the noncrossing test, we pick a linear function f which vanishes on L.  We then consider the polynomial G=numerator(fF).   As long as the denominators of the rational functions defining F do not vanish on P, the statement that G does not change signs on P is equivalent to the statement that F(P) does not cross L.  So, to apply the line test, we check that the denominators of F do not vanish on P and then we check that one of G or -G is nonnegative on P.";

	S=S+"\n\nFor the purpose of describing the excluder algorithm below, we introduce one bit of terminology. We say that the triple (F,P,L) strongly passes the line test if the function G=numerator(fF) defined above is already positive dominant.  Typically this does not happen. However, our recursive subdivision algorithm produces a finite partition of P into triangles Q1,...,Qn such that each (F,Qj,L) strongly passes the line test.";

	return(S);

    }

    public static String go67(Manager M) {

	String S="Excluder Test:  We use this test when we want to show that the image F(P) is disjoint from the interior of a convex polygon Q.  At first the excluder test looks weaker than the confiner test, but in fact it is much more versatile.  For instance, if we want to show that F(P) is contained in a nonconvex polygon R, we can put little polygons around the edges of R and apply the excluder test multiple times to show that F(P) does not cross the boundary of R.  So, at the expense of more computation, the excluder test could be used to give much more refined information.  We do not develop the excluder test in this way, but we want to point out its potential.";

	S=S+"\n\nThe excluder test is another recursive subdivision algorithm.  The input is a triple (F,P,Q), and we want to show that F(P) is disjoint from the interior of Q.   We first triangulate and reduce to the case that P is a triangle. We then maintain a list LIST of triangles.  Initially LIST consists of P itself.";

	S=S+"\n\nAt the working step of the algorithm, we let R be the last polygon on LIST.  Let L1,...,Lk be the lines extending the sides of Q. We check if some triple (F,R,Lj) strongly passes the line test and if the line Lj separates some prechosen point of F(R) from some prechosen point in the interior of Q.  Under these circumstances, some line extending an edge of Q separates F(R) from the interior of Q.  If R passes this check, we delete R from LIST and repeat.  If R fails, we delete R from LIST and append to LIST the four triangles in the subdivision of R.";

	S=S+"\n\nWe run the algorithm either until LIST is empty or else we reach a depth of 8 subdivisions.  In the former case, we have produced a partition of P into triangles R1,...,Rn such that each F(Rj) is separated from the interior of Q by some line extending an edge of Q.  But then F(P) is disjoint from the interior of Q.";

	return(S);

    }

    public static String go68(Manager M) {
	int[] a={1,0,0,0,1,1,1,1};
	DocumentProof.setDisplay(M,a);
	M.C.TEST.forceMode(1);
	M.C.TESTCHOICE.count=2;
	M.C.TESTCHOICE.on[0]=1;
	M.C.TESTCHOICE.on[1]=0;
	M.C.TC.setPiece(20,M);
	M.C.STRICT.val=1;
	M.C.TC.FILL.val=0;  
        M.P.setScales(0,530,40);


	String S="Ultimately, our test comes down to a finite number of verifications that a pair (F,P) is dominant.  You can set the program up so that you can do these calculations individually, and inspect the output of the program.  Here is how you do it.";
	S=S+DocumentTests.testRestrictString();
	S=S+"\n\nWe have currently set the program in a configuration which lets you do this. Just press GO, wait for the test to complete, and then press the trace button.  Once the trace is done, you can inspect the file trace_result to see the output of the basic unit of verification.";
	return(S);
    }


}
