


public class DocumentProofMiddle {

    public static void setup(Manager M,int n) {
	int[] a={1,0,0,1,1,1};
	DocumentProof.setDisplay(M,a);
	M.C.TC.FILL.val=1; 
	M.C.TC.setPiece(n,M);
	int[] t={34,35,36};
	M.setPieces(t);
    }

    public static String go41(Manager M) {
	setup(M,34);
        M.P.setScales(150,550,40);

	String S="Recall that K is the component of the core which contains the Cantor set JC.  Recall also that \u03A9 is the triangular fundamental domain for the Gauss group. Let L be the union of the 8 light red pieces.  Our goal in this part of the proof is to show that every point of \u03A9-K is mapped into L.";

	S=S+"\n\n(P1) We start with the large pieces.  Let P be the highlighted navy piece.  We do not associate a primary map to P but rather a map of the form BF where F is a primary map, and B is the coordinatewise map used to normalize the heat semigroup.  (If you push the 'algebra' button on the 'info' panel, you can see a formula for B.)";

	S=S+"\n\nB carries the convex set C to the unit square S, shown in black on the screen.  So, F(P) lies in C if and only if BF(P) lies in S.  The screen also shows (the boundary of) BF(P) in green, and you can see that it lies in S.  We will explain in the algebra section how we give a rigorous proof that BF(P) lies in S.";

	S=S+"\n\nThere are 3 pieces with this property.  They are the two largest red pieces and the two largest blue pieces.  Their piece numbers are 34,35,36.  You can see their images by clicking on them.  Alternatively, if you click on the row of squares at the bottom of the proof console, you can see the pieces set automatically.";

	return(S);
    }


    public static String go42(Manager M) {
	setup(M,17); 
        M.P.setScales(450,250,6);
	int[] t={17,19,31};
	M.setPieces(t);

	String S="(P2) Now we turn to the remaining blue pieces.  There are 3 of them, and they have indices 17,19,31.  (Actually, we could amagamate these pieces in pairs, but we will find it useful later in the proof to have them separate.) Let P be one of the blue pieces, like the one highlighted. Let F be the associated primary map.  We check that F(P) is contained in a certain hexagon Q, outlined in white in the figure. (You have to zoom out to see all of F(P) and Q.)  The same hexagon Q contains the images of the other blue pieces.";

	S=S+"We have\n\nQ=R1 \u2229 R2 \u2229 S, where:";

	S=S+"\n\nR1 is the largest dark red pieces.  This piece, the red part of Q, is mapped into the set C by the primary maps.";

	S=S+"R2 is the image of R2 under the reflection in the diagonal line through the origin.  Hence, by symmetry, all the primary maps carry R2 into C as well.";

	S=S+"\n\nS is already a subset of C.";

	S=S+"\n\nHence all the blue pieces are mapped into C after one or two iterations of the primary maps.";

	S=S+"\n\nThe same argument works for the thin red triangle, the piece with index 34.";
	return(S);
    }

    public static String go43(Manager M) {
	setup(M,14);    
        M.P.setScales(150,500,25); 
	int[] t={14,18,25,30};
	M.setPieces(t);

	String S="(P3) Now we deal with the 4 green pieces to the right of L.  One of the pieces is highlighted. Let P be one of these pieces and let F be the associated primary map.  We show that F(P) lies in a union of L and pieces considered in (P1) and (P2). So, every point of P either maps into L or maps into C after at most 3 iterations.";

	S=S+"\n\nThe screen also shows an auxiliary polygon. What we actually show is that F(P) is contained in this auxiliary polygon, and that this auxiliary polygon is contained in the union of L and (P1) and (P2).  Indeed, to each piece we want to control, we associate an auxiliary polygon and then show that the image of the piece lies in this polygon.";

	return(S);
    }


    public static String go44(Manager M) {
	setup(M,23);   
        M.P.setScales(150,500,25); 
	int[] t={23,15,21,27,24,28};
	M.setPieces(t);

	String S="(P4) Now we deal with the 6 dark green pieces to the left of L.  These pieces have indices 15,22,24,25,28,29. One of the pieces is highlighted. Let P be one of these pieces and let F be the associated primary map.  We show that F(P) lies in a union of L and pieces considered in (P1), (P2), (P3). So, every point of P either maps into L or maps into C after at most 4 iterations.  The screen shows the auxiliary polygon we use as in (P3).";

	return(S);
    }



    public static String go45(Manager M) {
	setup(M,20);   
        M.P.setScales(150,500,25);
	int[] t={20,26,37};
	M.setPieces(t);
 

	String S="(P5) Now we deal with the 3 light green triangular pieces. These pieces have indices 21,27,40.  One of the pieces is highlighted. Let P be one of these pieces and let F be the associated primary map.  We show that F(P) lies in a union of L and pieces considered in (P1), (P2), (P3), (P4). So, every point of P either maps into L or maps into C after at most 5 iterations.  The screen shows the auxiliary polygon we use as in (P4).";

	return(S);
    }



    public static String go46(Manager M) {
	setup(M,4);   
        M.P.setScales(150,500,25); 
	M.piecesOff();

	String S="(P6) Now we deal with the highlighted purple piece.  Let P be the piece and let F be the associated primary map.  We give a 2 step argument.";

	S=S+"\n\nWe show that F(P) is contained in a union of P, and the pieces of (P1) and (P2).";
	S=S+"\n\n Using the same method in Part 7 of the Cantor set proof, we show that F is an expanding map on P. Moreover F fixes the vertex of P that lies in JC.  From this, we see that every other point of P is ejected from P by some power of F.  Hence, each point of P, aside from the special vertex in JC, is mapped into L by some member of the heat semigroup.";

	return(S);
    }


    public static String go47(Manager M) {
	setup(M,5);   
        M.P.setScales(150,500,25); 
	M.piecesOff();

	String S="(P7) Finally we deal with the other purple piece. This is the last piece we need to treat.  Let P be the piece and let F be the associated primary map.  We give a 2 step argument similar to what we just did.";

	S=S+"\n\nWe show that F(P) is contained in a union of P, and the pieces of (P1),...,(P6).";

	S=S+"\n\n Using the same method in Part 7 of the Cantor set proof, we show that F is an expanding map on P. Moreover F fixes the vertex of P that lies in JC. The rest of the argument is as in the previous step.";

	return(S);
    }








}
