import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;


public class QI2PositiveTest implements Runnable {
    QI2Polynomial[] POLY=new QI2Polynomial[10];
    int POLYCOUNT;
    QI2Polygon DOMAIN;
    QITestWrapper QIT;
    int TRI;
    long TIME;
    MonitorTests MT;
    int CHOICE;
    int STRICT;

    public QI2PositiveTest() {}

    public QI2PositiveTest(QITestWrapper qit,QI2Polynomial[] x,QI2Polygon u,int strict) {
	POLY=x;
	DOMAIN=u;
	QIT=qit;
	TIME=time();
	MT=QIT.M.TC.MT;
	System.out.println("test leng "+x.length);
	for(int i=0;i<x.length;++i) POLY[i]=x[i];
	POLYCOUNT=x.length;
	STRICT=strict;
    }


    public void run() {
      QI2Polygon[] LIST=DOMAIN.toSubdivision();
      for(int j=0;j<POLYCOUNT;++j) { 
        initialize(j);
        boolean test=main(POLY[j],LIST);
	if(test==false) {
	  doFail();
	  return;
	}
      }
      doPass();
    }


    public boolean main(QI2Polynomial Y,QI2Polygon[] T) {
	int count=0;
	int record=0;
	QI2Polygon[] LIST=QI2Polygon.copy(T);
	while((QIT.HALT==false)&&(LIST.length>0)) {
	    QI2Polygon W=LIST[LIST.length-1]; 
	    if(record<W.age) record=W.age;  
            sendDepth(W.age,record,count); 
	    boolean test=checkDominance(Y,W);
	    if(test==true) { 
                ++count;
                LIST=QI2Polygon.truncate(LIST);	 
	    }
	    if(test==false) LIST=QI2Polygon.refine(LIST);  
            if(record>8) return(false);
	}
	if(QIT.HALT==false) return(true);
	return(false);
    }


    public boolean checkDominance(QI2Polynomial Y,QI2Polygon WW) {
	QI2Polygon W=new QI2Polygon(WW);
	int sign=0;
	for(int i=0;i<3;++i) {
  	   boolean test=false;
           QI2Polynomial Z=Y.moveTriangle(W);
           Z=Z.squareTriangleTransform(); 

	   if(STRICT==0) {
	      sign=Z.dominanceTest(0);
	      if(sign!=0) test=true;
	   }

           if(STRICT==1) {
	      sign=0;
              test=Z.isPositiveDominantHard();
	   }

	   if(test==true) { 
	      W.color=sign+1;
	      W.testnumber=CHOICE;
              sendPoly(W);
              return(true);
	   }
	   W=W.rotate();
	}
	return(false);
    }

    /**These are communications with the program*/

    public void initialize(int j) {
        Integer J=new Integer(j+1);
	MT.S[1]="polynomial "+J.toString();
        QIT.M.P.TR.COUNT=0;
	CHOICE=j;
    }

    public void doFail() {
        QIT.HALT=true;
        MT.S[0]="test fail";  
        MT.STATE=2; 
	QIT.M.repaint();
    }

    public void doPass() {
      MT.S[0]="test pass";  
      MT.STATE=1;
      QIT.HALT=true;
      QIT.M.repaint();

    }

    public void sendPoly(QI2Polygon W) {
	Tracer TR=QIT.M.P.TR;
	int c=TR.COUNT;
	TR.LIST[c]=W;
	++TR.COUNT;
    }

    public void sendDepth(int a,int b,int c) {
	MT.DEPTH[0]=a;
	MT.DEPTH[1]=b;
	MT.DEPTH[2]=c;
	MT.TIME=time()-TIME;
	QIT.M.repaint();
    }

    public static long time() {
	long t=System.currentTimeMillis();
	return(t);
    }


}







